Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/App.config
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/App.config	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/App.config	(revision 2771)
@@ -3,4 +3,41 @@
   <configSections>
   </configSections>
+  <system.diagnostics>
+    <sources>
+      <source name="System.ServiceModel.MessageLogging" switchValue="Warning, ActivityTracing">
+        <listeners>
+          <add type="System.Diagnostics.DefaultTraceListener" name="Default">
+            <filter type="" />
+          </add>
+          <add name="ServiceModelMessageLoggingListener">
+            <filter type="" />
+          </add>
+        </listeners>
+      </source>
+      <source name="System.ServiceModel" switchValue="Warning, ActivityTracing"
+        propagateActivity="true">
+        <listeners>
+          <add type="System.Diagnostics.DefaultTraceListener" name="Default">
+            <filter type="" />
+          </add>
+          <add name="ServiceModelTraceListener">
+            <filter type="" />
+          </add>
+        </listeners>
+      </source>
+    </sources>
+    <sharedListeners>
+      <add initializeData="c:\users\p40086\documents\heuristiclab\hl3-core\branches\deploymentserver prototype\heuristiclab.services\heuristiclab.services.deployment\app_messages.svclog"
+        type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
+        name="ServiceModelMessageLoggingListener" traceOutputOptions="Timestamp">
+        <filter type="" />
+      </add>
+      <add initializeData="c:\users\p40086\documents\heuristiclab\hl3-core\branches\deploymentserver prototype\heuristiclab.services\heuristiclab.services.deployment\app_tracelog.svclog"
+        type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
+        name="ServiceModelTraceListener" traceOutputOptions="Timestamp">
+        <filter type="" />
+      </add>
+    </sharedListeners>
+  </system.diagnostics>
   <connectionStrings>
     <add name="HeuristicLab.Services.Deployment.Properties.Settings.HeuristicLab_PluginStoreConnectionString"
@@ -14,13 +51,30 @@
   app.config file. System.Configuration does not support config files for libraries. -->
   <system.serviceModel>
+    <bindings>
+      <wsHttpBinding>
+        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="10000000"
+          maxReceivedMessageSize="1000000">
+          <readerQuotas maxDepth="1000" maxStringContentLength="16000"
+            maxArrayLength="10000000" maxBytesPerRead="10000000" maxNameTableCharCount="16000" />
+        </binding>
+      </wsHttpBinding>
+      <mexHttpBinding>
+        <binding name="DefaultMexHttpBinding" />
+      </mexHttpBinding>
+    </bindings>
+    <diagnostics performanceCounters="Default">
+      <messageLogging logMalformedMessages="true" logMessagesAtTransportLevel="true" />
+    </diagnostics>
     <services>
       <service behaviorConfiguration="HeuristicLab.Services.Deployment.UpdateBehavior"
         name="HeuristicLab.Services.Deployment.Update">
-        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Services.Deployment.IUpdate">
+        <endpoint address="" binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IUpdate">
           <identity>
             <dns value="localhost" />
           </identity>
         </endpoint>
-        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
+        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding"
+          contract="IMetadataExchange" />
         <host>
           <baseAddresses>
@@ -31,10 +85,12 @@
       <service behaviorConfiguration="HeuristicLab.Services.Deployment.AdminBehavior"
         name="HeuristicLab.Services.Deployment.Admin">
-        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Services.Deployment.IAdmin">
+        <endpoint address="" binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IAdmin">
           <identity>
             <dns value="localhost" />
           </identity>
         </endpoint>
-        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
+        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding"
+          contract="IMetadataExchange" />
         <host>
           <baseAddresses>
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IAdmin.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IAdmin.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IAdmin.cs	(revision 2771)
@@ -12,5 +12,5 @@
   public interface IAdmin {
     [OperationContract]
-    void StoreProduct(ProductDescription product);
+    void DeployProduct(ProductDescription product);
 
     [OperationContract]
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IUpdate.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IUpdate.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/IUpdate.cs	(revision 2771)
@@ -17,4 +17,6 @@
     IEnumerable<ProductDescription> GetProducts();
 
+    [OperationContract]
+    IEnumerable<PluginDescription> GetPlugins();
   }
 }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/Update.cs
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/Update.cs	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services.Deployment/Update.cs	(revision 2771)
@@ -23,4 +23,9 @@
     }
 
+    public IEnumerable<PluginDescription> GetPlugins() {
+      PluginStore store = new PluginStore();
+      return store.Plugins;
+    }
+
     #endregion
   }
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services/Web.config
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services/Web.config	(revision 2770)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/HeuristicLab.Services/Web.config	(revision 2771)
@@ -9,26 +9,21 @@
 -->
 <configuration>
-
-
-    <configSections>
-      <sectionGroup name="system.web.extensions" type="System.Web.Configuration.SystemWebExtensionsSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
-        <sectionGroup name="scripting" type="System.Web.Configuration.ScriptingSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
-          <section name="scriptResourceHandler" type="System.Web.Configuration.ScriptingScriptResourceHandlerSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
-          <sectionGroup name="webServices" type="System.Web.Configuration.ScriptingWebServicesSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
-            <section name="jsonSerialization" type="System.Web.Configuration.ScriptingJsonSerializationSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="Everywhere" />
-            <section name="profileService" type="System.Web.Configuration.ScriptingProfileServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
-            <section name="authenticationService" type="System.Web.Configuration.ScriptingAuthenticationServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
-            <section name="roleService" type="System.Web.Configuration.ScriptingRoleServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication" />
-          </sectionGroup>
-        </sectionGroup>
-      </sectionGroup>
-    </configSections>  
-
-
-    <appSettings/>
-    <connectionStrings/>
-
-    <system.web>
-        <!--
+	<configSections>
+		<sectionGroup name="system.web.extensions" type="System.Web.Configuration.SystemWebExtensionsSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+			<sectionGroup name="scripting" type="System.Web.Configuration.ScriptingSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+				<section name="scriptResourceHandler" type="System.Web.Configuration.ScriptingScriptResourceHandlerSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
+				<sectionGroup name="webServices" type="System.Web.Configuration.ScriptingWebServicesSectionGroup, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35">
+					<section name="jsonSerialization" type="System.Web.Configuration.ScriptingJsonSerializationSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="Everywhere"/>
+					<section name="profileService" type="System.Web.Configuration.ScriptingProfileServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
+					<section name="authenticationService" type="System.Web.Configuration.ScriptingAuthenticationServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
+					<section name="roleService" type="System.Web.Configuration.ScriptingRoleServiceSection, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" requirePermission="false" allowDefinition="MachineToApplication"/>
+				</sectionGroup>
+			</sectionGroup>
+		</sectionGroup>
+	</configSections>
+	<appSettings/>
+	<connectionStrings/>
+	<system.web>
+		<!--
             Set compilation debug="true" to insert debugging 
             symbols into the compiled page. Because this 
@@ -36,19 +31,17 @@
             during development.
         -->
-        <compilation debug="false">
-
-          <assemblies>
-            <add assembly="System.Core, Version=3.5.0.0, Culture=neutral, PublicKeyToken=B77A5C561934E089"/>
-            <add assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-          </assemblies>
-
-        </compilation>
-        <!--
+		<compilation debug="true">
+			<assemblies>
+				<add assembly="System.Core, Version=3.5.0.0, Culture=neutral, PublicKeyToken=B77A5C561934E089"/>
+				<add assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			</assemblies>
+		</compilation>
+		<!--
             The <authentication> section enables configuration 
             of the security authentication mode used by 
             ASP.NET to identify an incoming user. 
         -->
-        <authentication mode="Windows" />
-        <!--
+		<authentication mode="Windows"/>
+		<!--
             The <customErrors> section enables configuration 
             of what to do if/when an unhandled error occurs 
@@ -62,101 +55,91 @@
         </customErrors>
         -->
-
-
-      <pages>
-        <controls>
-          <add tagPrefix="asp" namespace="System.Web.UI" assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-        </controls>
-      </pages>
-
-      <httpHandlers>
-        <remove verb="*" path="*.asmx"/>
-        <add verb="*" path="*.asmx" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-        <add verb="*" path="*_AppService.axd" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-        <add verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" validate="false"/>
-      </httpHandlers>
-      <httpModules>
-        <add name="ScriptModule" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-      </httpModules>
-
-
-    </system.web>
-
-    <system.codedom>
-      <compilers>
-        <compiler language="c#;cs;csharp" extension=".cs" warningLevel="4"
-                  type="Microsoft.CSharp.CSharpCodeProvider, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
-          <providerOption name="CompilerVersion" value="v3.5"/>
-          <providerOption name="WarnAsError" value="false"/>
-        </compiler>
-      </compilers>
-    </system.codedom>
-
-    <!--
+		<pages>
+			<controls>
+				<add tagPrefix="asp" namespace="System.Web.UI" assembly="System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			</controls>
+		</pages>
+		<httpHandlers>
+			<remove verb="*" path="*.asmx"/>
+			<add verb="*" path="*.asmx" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			<add verb="*" path="*_AppService.axd" validate="false" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			<add verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" validate="false"/>
+		</httpHandlers>
+		<httpModules>
+			<add name="ScriptModule" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+		</httpModules>
+	</system.web>
+	<system.codedom>
+		<compilers>
+			<compiler language="c#;cs;csharp" extension=".cs" warningLevel="4" type="Microsoft.CSharp.CSharpCodeProvider, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+				<providerOption name="CompilerVersion" value="v3.5"/>
+				<providerOption name="WarnAsError" value="false"/>
+			</compiler>
+		</compilers>
+	</system.codedom>
+	<!--
         The system.webServer section is required for running ASP.NET AJAX under Internet
         Information Services 7.0.  It is not necessary for previous version of IIS.
     -->
-    <system.webServer>
-      <validation validateIntegratedModeConfiguration="false"/>
-      <modules>
-        <add name="ScriptModule" preCondition="integratedMode" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-      </modules>
-      <handlers>
-        <remove name="WebServiceHandlerFactory-Integrated"/>
-        <add name="ScriptHandlerFactory" verb="*" path="*.asmx" preCondition="integratedMode"
-             type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-        <add name="ScriptHandlerFactoryAppServices" verb="*" path="*_AppService.axd" preCondition="integratedMode"
-             type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
-        <add name="ScriptResource" preCondition="integratedMode" verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" />
-      </handlers>
-    </system.webServer>
-
-
-  <system.serviceModel>
-    <services>
-      <service behaviorConfiguration="HeuristicLab.Services.Service1Behavior"
-        name="HeuristicLab.Services.Service1">
-        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Services.IService1">
-          <identity>
-            <dns value="localhost" />
-          </identity>
-        </endpoint>
-        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
-      </service>
-      <service behaviorConfiguration="HeuristicLab.Services.UpdateBehavior"
-        name="HeuristicLab.Services.Update">
-        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Services.IUpdate">
-          <identity>
-            <dns value="localhost" />
-          </identity>
-        </endpoint>
-        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
-      </service>
-      <service behaviorConfiguration="HeuristicLab.Services.AdminBehavior"
-        name="HeuristicLab.Services.Admin">
-        <endpoint address="" binding="wsHttpBinding" contract="HeuristicLab.Services.IAdmin">
-          <identity>
-            <dns value="localhost" />
-          </identity>
-        </endpoint>
-        <endpoint address="mex" binding="mexHttpBinding" contract="IMetadataExchange" />
-      </service>
-    </services>
-    <behaviors>
-      <serviceBehaviors>
-        <behavior name="HeuristicLab.Services.Service1Behavior">
-          <serviceMetadata httpGetEnabled="true" />
-          <serviceDebug includeExceptionDetailInFaults="false" />
-        </behavior>
-        <behavior name="HeuristicLab.Services.UpdateBehavior">
-          <serviceMetadata httpGetEnabled="true" />
-          <serviceDebug includeExceptionDetailInFaults="false" />
-        </behavior>
-        <behavior name="HeuristicLab.Services.AdminBehavior">
-          <serviceMetadata httpGetEnabled="true" />
-          <serviceDebug includeExceptionDetailInFaults="false" />
-        </behavior>
-      </serviceBehaviors>
-    </behaviors>
-  </system.serviceModel>
+	<system.webServer>
+		<validation validateIntegratedModeConfiguration="false"/>
+		<modules>
+			<add name="ScriptModule" preCondition="integratedMode" type="System.Web.Handlers.ScriptModule, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+		</modules>
+		<handlers>
+			<remove name="WebServiceHandlerFactory-Integrated"/>
+			<add name="ScriptHandlerFactory" verb="*" path="*.asmx" preCondition="integratedMode" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			<add name="ScriptHandlerFactoryAppServices" verb="*" path="*_AppService.axd" preCondition="integratedMode" type="System.Web.Script.Services.ScriptHandlerFactory, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+			<add name="ScriptResource" preCondition="integratedMode" verb="GET,HEAD" path="ScriptResource.axd" type="System.Web.Handlers.ScriptResourceHandler, System.Web.Extensions, Version=3.5.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+		</handlers>
+	</system.webServer>
+	<system.serviceModel>
+		<bindings>
+   <wsHttpBinding>
+    <binding name="DefaultWsBindingConfiguration">
+     <readerQuotas maxDepth="1000" maxStringContentLength="1000000"
+      maxArrayLength="1000" maxBytesPerRead="1000000" maxNameTableCharCount="1000" />
+    </binding>
+   </wsHttpBinding>
+   <mexHttpBinding>
+    <binding name="DefaultMexBindingConfiguration" />
+   </mexHttpBinding>
+  </bindings>
+  <services>
+   <service behaviorConfiguration="HeuristicLab.Services.UpdateBehavior"
+    name="HeuristicLab.Services.Update">
+    <endpoint address="" binding="wsHttpBinding" bindingConfiguration="DefaultWsBindingConfiguration"
+     contract="HeuristicLab.Services.IUpdate">
+     <identity>
+      <dns value="localhost" />
+     </identity>
+    </endpoint>
+    <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexBindingConfiguration"
+     contract="IMetadataExchange" />
+   </service>
+   <service behaviorConfiguration="HeuristicLab.Services.AdminBehavior"
+    name="HeuristicLab.Services.Admin">
+    <endpoint address="" binding="wsHttpBinding" bindingConfiguration="DefaultWsBindingConfiguration"
+     contract="HeuristicLab.Services.IAdmin">
+     <identity>
+      <dns value="localhost" />
+     </identity>
+    </endpoint>
+    <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexBindingConfiguration"
+     contract="IMetadataExchange" />
+   </service>
+  </services>
+		<behaviors>
+   <serviceBehaviors>
+    <behavior name="HeuristicLab.Services.UpdateBehavior">
+     <serviceMetadata httpGetEnabled="true" />
+     <serviceDebug includeExceptionDetailInFaults="false" />
+    </behavior>
+    <behavior name="HeuristicLab.Services.AdminBehavior">
+     <serviceMetadata httpGetEnabled="true" />
+     <serviceDebug includeExceptionDetailInFaults="false" />
+    </behavior>
+   </serviceBehaviors>
+  </behaviors>
+	</system.serviceModel>
 </configuration>
Index: /branches/DeploymentServer Prototype/HeuristicLab.Services/PreBuildEvent.cmd
===================================================================
--- /branches/DeploymentServer Prototype/HeuristicLab.Services/PreBuildEvent.cmd	(revision 2771)
+++ /branches/DeploymentServer Prototype/HeuristicLab.Services/PreBuildEvent.cmd	(revision 2771)
@@ -0,0 +1,1 @@
+SubWCRev "%ProjectDir%\" "%ProjectDir%\Properties\AssemblyInfo.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
